clear all; close all; clc

syms x_d y_d
table = readtable('Localization_2.xlsx');

%S = [2;7;10;15;18;32;35;49];
S = [2;7;10;15;18;23;26;40;43;57;60;74]; % Row
COL = [2;7;9;10;16;17];

for r = 1:6
    
start = S(2*r-1); finish = S(2*r);

for read = 1:2 %Read column 3,4,5,6 (TOA)
    
for j = start:finish

x = table2array(table(j,COL(1):COL(2))); x = cellfun(@str2num,x); %Sensor location: COL 2-7
t = table2array(table(j,COL(2*read+1):COL(2*read+2))); t = cellfun(@str2num,t); %TOA: COL 9-10/16-17
x = x./100; % Convert to meter
dx = sym(zeros(6,1)); % Reserve variable for distance between sensor, actuator, and damage
v = 5313; % S0-Speed in m/s
t_1 = t(1)*1e-6; % Convert TOA Sensor 1 to s
t_2 = t(2)*1e-6; % Convert TOA Sensor 2 to s

for i = 1:3
   dx(2*i-1) = x(2*i-1) - x_d; %Calculate dx
   dx(2*i) = x(2*i) - y_d; %Calculate dy
end

eqn1 = sqrt(dx(1).^2 + dx(2).^2) + sqrt(dx(3).^2 + dx(4).^2) == v*t_1; % Eq. 1
eqn2 = sqrt(dx(1).^2 + dx(2).^2) + sqrt(dx(5).^2 + dx(6).^2) == v*t_2; % Eq. 2
eqns = [eqn1 eqn2]; % Put both equations in matrices
vars = [x_d y_d]; % Reserve variables for solution
[solv, solu] = solve(eqns, vars); % Calculate solution for Eq. 1 and 2

%Replace any empty or imaginary values with 0,0
if isempty(round(double(solv)*100)')
    sol_1 = [0,0];
    sol_1(imag(sol_1) ~= 0) = 0;
else
    sol_1 = round(double(solv)*100)';
    sol_1(imag(sol_1) ~= 0) = 0;
end

if isempty(round(double(solu)*100)')
    sol_2 = [0,0];
    sol_2(imag(sol_2) ~= 0) = 0;
else
    sol_2 = round(double(solu)*100)';
    sol_2(imag(sol_2) ~= 0) = 0;
end

sol(j-start+1,:) = real([sol_1,sol_2]); %Save the solutions in vector
end

sol_cell{r,read} = sol; % Save the vector solutions in cell

fprintf('Calculating... \n')
end

solution{r} = [sol_cell{r,1};sol_cell{r,2}]; %Concatenate both solutions
solution{r}(all(~solution{r},2), : ) = []; %Remove rows with all zero

end